# Meshy Rigging Multi Animation API

> ทำริกให้ GLB รูปมนุษย์หนึ่งครั้ง และฝังพรีเซ็ตแอนิเมชันหลายรายการในการทำงานครั้งเดียว

ทำริกให้ GLB รูปมนุษย์จาก `model_url` และสร้างคลิปแอนิเมชันหนึ่งรายการสำหรับแต่ละ ID ใน `animation_action_ids` โดยใช้ริกเดียวกัน คลิปต่าง ๆ จะถูกส่งกลับตามลำดับคำขอในอาร์เรย์ `animations` พร้อมไฟล์ GLB และ FBX ที่ทำริกแล้ว รวมถึงแอนิเมชันเดินและวิ่งพื้นฐาน ต้องมี ID อย่างน้อยหนึ่งรายการ `height_meters` ใช้กำหนดความสูงโดยประมาณของตัวละคร

- Model id: `meshy/rigging/multi-animation`
- Made by: Meshy
- Category: 3D
- Output: json
- Price per run: $0.20 / run (cheapest run $0.20 (200 API credits))
- Run: `POST https://api.doitong.com/v1/run/meshy/rigging/multi-animation`
- Quote: `POST https://api.doitong.com/v1/quote/meshy/rigging/multi-animation`
- Docs page: https://doitong.com/th/developers/models/meshy/rigging/multi-animation

## Pricing

Price: **$0.20 / run**. Price per run: the input files are measured before the run (length, resolution, frame rate). The quote measures the same files and is exactly what the run charges.

The full example input below costs $0.44 = 440 API credits (1 run × $0.44).

Prices are the upstream price in USD, paid from the API balance in API credits (1000 API credits = 1 USD). `POST https://api.doitong.com/v1/quote/meshy/rigging/multi-animation` with the same JSON body returns the exact price for that input; the quote is exactly what a run charges. Invalid input is never charged and failed or canceled requests are refunded automatically.

## Input parameters

| Parameter | Canonical name | Type | Required | Default | Allowed values / range | Description |
|---|---|---|---|---|---|---|
| `model_url` |  | string | yes |  | ≥ 1 characters | URL สำหรับทำ rigging และใส่แอนิเมชันให้ตัวละคร 3D รูปมนุษย์ที่มีแขนขาแยกแยะได้อย่างชัดเจน URL ต้องเข้าถึงได้แบบสาธารณะและชี้ไปยังไฟล์ GLB โดยโมเดลอาจมาจาก Hunyuan, Trellis, Meshy หรือเครื่องมือสร้าง 3D อื่น |
| `height_meters` |  | number | no | `1.7` | > 0 | ความสูงโดยประมาณของตัวละคร วัดเป็นเมตร |
| `animation_action_ids` |  | array of integer | yes |  |  | รหัสแอนิเมชันที่กำหนดไว้ล่วงหน้าจากไลบรารี Meshy ต้องมีอย่างน้อยหนึ่งรายการ แต่ละรายการอยู่ในช่วง [0, 696] โดยมีคลิปที่ไม่ซ้ำกันได้สูงสุด 10 คลิปและตัดค่าซ้ำออก แต่ละรหัสจะสร้างคลิปโดยใช้ rig เดียวกัน และส่งคืนในอาร์เรย์ animations ตามลำดับที่ร้องขอ รหัสที่ใช้ได้มีเอกสารอยู่ที่ https://docs.meshy.ai/en/api/animation-library |
| `enable_safety_checker` |  | boolean | no | `true` |  | สวิตช์ตรวจสอบความปลอดภัยก่อนการประมวลผล: true ทำให้การตรวจสอบความปลอดภัยของอินพุตเป็นเงื่อนไขที่ต้องทำก่อนประมวลผล |

## Example input

Required parameters only:

```json
{
  "model_url": "https://example.com/your-file.glb",
  "animation_action_ids": [
    36,
    92
  ]
}
```

A fuller example:

```json
{
  "model_url": "https://example.com/your-file.glb",
  "animation_action_ids": [
    36,
    92
  ]
}
```

## Run it

Set `DOITONG_API_KEY` to a key from https://doitong.com/developers/dashboard#keys. `?wait=20` returns the finished request in the same call when it is ready within 20 seconds; otherwise poll `GET /requests/{id}` (it also accepts `?wait=`), or pass `webhook_url`.

### curl

```bash
# Run the model; wait up to 20 s for the finished result in the same call
curl -X POST "https://api.doitong.com/v1/run/meshy/rigging/multi-animation?wait=20" \
  -H "Authorization: Bearer $DOITONG_API_KEY" \
  -H "Content-Type: application/json" \
  -d '{
    "model_url": "https://example.com/your-file.glb",
    "animation_action_ids": [
      36,
      92
    ]
  }'

# Still "queued" or "running"? Poll with the id from the response:
curl "https://api.doitong.com/v1/requests/REQUEST_ID?wait=20" \
  -H "Authorization: Bearer $DOITONG_API_KEY"
```

### JavaScript

```javascript
const API = "https://api.doitong.com/v1";
const headers = {
  "Authorization": "Bearer " + process.env.DOITONG_API_KEY,
  "Content-Type": "application/json",
};

// Run the model; wait up to 20 s for the finished result in the same call
let res = await fetch(API + "/run/meshy/rigging/multi-animation?wait=20", {
  method: "POST",
  headers,
  body: JSON.stringify({
    "model_url": "https://example.com/your-file.glb",
    "animation_action_ids": [
      36,
      92
    ]
  }),
});
let request = await res.json();
if (!res.ok) throw new Error(request.error.code + ": " + request.error.message);

// Not finished yet: long-poll until it is
while (request.status === "queued" || request.status === "running") {
  res = await fetch(API + "/requests/" + request.id + "?wait=20", { headers });
  request = await res.json();
}
if (request.status !== "succeeded") throw new Error(JSON.stringify(request.error));
console.log(request.outputs.map((o) => o.url), request.cost.credits + " API credits ($" + request.cost.usd + ")");
```

### Python

```python
import os
import requests

API = "https://api.doitong.com/v1"
headers = {"Authorization": "Bearer " + os.environ["DOITONG_API_KEY"]}

payload = {
    "model_url": "https://example.com/your-file.glb",
    "animation_action_ids": [
        36,
        92,
    ],
}

# Run the model; wait up to 20 s for the finished result in the same call
r = requests.post(API + "/run/meshy/rigging/multi-animation", params={"wait": 20}, json=payload, headers=headers)
request = r.json()
if not r.ok:
    raise RuntimeError(request["error"]["code"] + ": " + request["error"]["message"])

# Not finished yet: long-poll until it is
while request["status"] in ("queued", "running"):
    request = requests.get(API + "/requests/" + request["id"], params={"wait": 20}, headers=headers).json()
if request["status"] != "succeeded":
    raise RuntimeError(request["error"])
print([o["url"] for o in request["outputs"]], request["cost"]["credits"], "API credits", "$" + request["cost"]["usd"])
```

### MCP

The MCP server at `https://api.doitong.com/v1/mcp` exposes the tools `search_models`, `get_model`, `quote`, `run`, `get_request`, `cancel_request`, `list_requests`, `create_upload` and `get_account`. A `run` call for this model:

```json
{
  "jsonrpc": "2.0",
  "id": 1,
  "method": "tools/call",
  "params": {
    "name": "run",
    "arguments": {
      "model_id": "meshy/rigging/multi-animation",
      "input": {
        "model_url": "https://example.com/your-file.glb",
        "animation_action_ids": [
          36,
          92
        ]
      },
      "wait_seconds": 20
    }
  }
}
```

## Response

Every call returns a request object. `status` is one of `queued`, `running`, `succeeded`, `failed`, `canceled`. `outputs` lists the generated files with URLs on our storage (kept forever, or 7 days with `?storage=temporary`; `storage` says which); `output` is the model's own result object with the same URLs.

```json
{
  "id": "req_8k2m4q7x1z9c3v5b6n0p2r4t",
  "object": "request",
  "model": "meshy/rigging/multi-animation",
  "status": "succeeded",
  "created_at": "2026-10-20T12:00:00Z",
  "started_at": "2026-10-20T12:00:02Z",
  "completed_at": "2026-10-20T12:00:09Z",
  "queue_position": null,
  "cost": {
    "credits": 440,
    "usd": "0.44",
    "charged": 440,
    "refunded": 0
  },
  "input": {
    "model_url": "https://example.com/your-file.glb",
    "animation_action_ids": [
      36,
      92
    ]
  },
  "output": {
    "rigged_character_glb": {
      "url": "https://content.doitong.com/dev-api/2026/10/20/req_8k2m4q7x1z9c3v5b6n0p2r4t/0-output.jpeg",
      "content_type": "image/jpeg",
      "file_name": "0-output.jpeg",
      "file_size": 1843200
    },
    "rigged_character_fbx": {
      "url": "https://content.doitong.com/dev-api/2026/10/20/req_8k2m4q7x1z9c3v5b6n0p2r4t/0-output.jpeg",
      "content_type": "image/jpeg",
      "file_name": "0-output.jpeg",
      "file_size": 1843200
    },
    "basic_animations": {
      "walking_glb": {
        "url": "https://content.doitong.com/dev-api/2026/10/20/req_8k2m4q7x1z9c3v5b6n0p2r4t/0-output.jpeg",
        "content_type": "image/jpeg",
        "file_name": "0-output.jpeg",
        "file_size": 1843200
      },
      "walking_fbx": {
        "url": "https://content.doitong.com/dev-api/2026/10/20/req_8k2m4q7x1z9c3v5b6n0p2r4t/0-output.jpeg",
        "content_type": "image/jpeg",
        "file_name": "0-output.jpeg",
        "file_size": 1843200
      },
      "walking_armature_glb": {
        "url": "https://content.doitong.com/dev-api/2026/10/20/req_8k2m4q7x1z9c3v5b6n0p2r4t/0-output.jpeg",
        "content_type": "image/jpeg",
        "file_name": "0-output.jpeg",
        "file_size": 1843200
      },
      "running_glb": {
        "url": "https://content.doitong.com/dev-api/2026/10/20/req_8k2m4q7x1z9c3v5b6n0p2r4t/0-output.jpeg",
        "content_type": "image/jpeg",
        "file_name": "0-output.jpeg",
        "file_size": 1843200
      },
      "running_fbx": {
        "url": "https://content.doitong.com/dev-api/2026/10/20/req_8k2m4q7x1z9c3v5b6n0p2r4t/0-output.jpeg",
        "content_type": "image/jpeg",
        "file_name": "0-output.jpeg",
        "file_size": 1843200
      },
      "running_armature_glb": {
        "url": "https://content.doitong.com/dev-api/2026/10/20/req_8k2m4q7x1z9c3v5b6n0p2r4t/0-output.jpeg",
        "content_type": "image/jpeg",
        "file_name": "0-output.jpeg",
        "file_size": 1843200
      }
    },
    "animations": [
      {
        "action_id": 1,
        "animation_glb": {
          "url": "https://content.doitong.com/dev-api/2026/10/20/req_8k2m4q7x1z9c3v5b6n0p2r4t/0-output.jpeg",
          "content_type": "image/jpeg",
          "file_name": "0-output.jpeg",
          "file_size": 1843200
        },
        "animation_fbx": {
          "url": "https://content.doitong.com/dev-api/2026/10/20/req_8k2m4q7x1z9c3v5b6n0p2r4t/0-output.jpeg",
          "content_type": "image/jpeg",
          "file_name": "0-output.jpeg",
          "file_size": 1843200
        }
      }
    ],
    "rig_task_id": "string"
  },
  "outputs": [
    {
      "type": "file",
      "url": "https://content.doitong.com/dev-api/2026/10/20/req_8k2m4q7x1z9c3v5b6n0p2r4t/0-output.jpeg",
      "content_type": "image/jpeg",
      "file_size": 1843200,
      "stored": true
    }
  ],
  "error": null,
  "metrics": {
    "inference_seconds": 6.8
  },
  "urls": {
    "self": "https://api.doitong.com/v1/requests/req_8k2m4q7x1z9c3v5b6n0p2r4t",
    "cancel": "https://api.doitong.com/v1/requests/req_8k2m4q7x1z9c3v5b6n0p2r4t/cancel"
  }
}
```

### Output fields (`output`)

| Field | Type | Description |
|---|---|---|
| `rigged_character_glb` | object {url, content_type, file_name, file_size} \| null | ตัวละครรูปแบบ GLB ที่ผ่านการทำ rigging แล้ว |
| `rigged_character_fbx` | object {url, content_type, file_name, file_size} \| null | ตัวละครรูปแบบ FBX ที่ผ่านการทำ rigging แล้ว |
| `basic_animations` | object {walking_glb, walking_fbx, walking_armature_glb, running_glb, running_fbx, running_armature_glb} \| null | แอนิเมชันการเดินและการวิ่งพื้นฐานที่ให้มาพร้อมกับการทำ rigging |
| `animations` | array of object {action_id, animation_glb, animation_fbx} | ผลลัพธ์แอนิเมชันตามลำดับที่ตรงกับรหัสแอ็กชันในคำขอ แต่ละรหัสที่ร้องขอมีรายการหนึ่งรายการซึ่งมีคลิปที่สร้างโดยใช้ rig |
| `rig_task_id` | string \| null | ตัวระบุงานทำ rigging ใน Meshy |

## Related models

- [Meshy Rigging](https://doitong.com/developers/models/meshy/rigging.md) (`meshy/rigging`): from $0.20 / request
- [Meshy 6 Lite Retexture](https://doitong.com/developers/models/meshy/v6-lite/retexture.md) (`meshy/v6-lite/retexture`): $0.30 / request
- [Meshy 6 Retexture](https://doitong.com/developers/models/meshy/v6/retexture.md) (`meshy/v6/retexture`): from $0.30 / request
- [Meshy 7 Retexture](https://doitong.com/developers/models/meshy/v7/retexture.md) (`meshy/v7/retexture`): from $0.30 / request
- [Abot World 0](https://doitong.com/developers/models/alibaba/abot-world-0.md) (`alibaba/abot-world-0`): $0.001 / run
- [Hi3D 3D Part Splitter](https://doitong.com/developers/models/hitem3d/hi3d/split.md) (`hitem3d/hi3d/split`): $0.40 / run
- [Hi3D 3D to Multicolor](https://doitong.com/developers/models/hitem3d/hi3d/multicolor.md) (`hitem3d/hi3d/multicolor`): $0.40 / run
- [Hi3D Texture](https://doitong.com/developers/models/hitem3d/hi3d/texture.md) (`hitem3d/hi3d/texture`): $0.30 / run

## Links

- HTML page: https://doitong.com/developers/models/meshy/rigging/multi-animation
- All models and guides for AI agents: https://doitong.com/developers/llms.txt
- OpenAPI 3.1 with this model's typed request body: https://doitong.com/developers/openapi.json?model=meshy/rigging/multi-animation
- Errors: https://doitong.com/developers/docs/errors
- Model details as JSON: https://api.doitong.com/v1/models/meshy/rigging/multi-animation
